#!/bin/bash

soundreadymsg() {
if [ ! -z "$(locale|grep ja_JP)" ]; then
  msg1="オーディオシステムの準備ができました\n\n"
  msg2="　モード：$(cat /etc/konahqss/mode)\n" 
  msg3="　ジャンル：$(cat /etc/konahqss/janru)\n"
  if [ -f /etc/konahqss/fastmemcpy ] && [ -f /etc/konahqss/hqdriveready ]; then
    msg4="　高音質サウンドドライバー：動作中"
  else
    msg4=""
  fi
  msg="$(echo $msg1$msg2$msg3$msg4)"
  zenity --info --title="オーディオ準備完了" --text="$msg" --no-wrap --timeout=8
else
  msg1="Audio system is ready\n\n"
  msg2="  Mode : $(cat /etc/konahqss/mode)\n" 
  msg3="  Janru : $(cat /etc/konahqss/janru)\n"
  if [ -f /etc/konahqss/fastmemcpy ] && [ -f /etc/konahqss/hqdriveready ]; then
    msg4="  High quality sound driver : Active"
  else
    msg4=""
  fi
  msg="$(echo $msg1$msg2$msg3$msg4)"
  zenity --info --title="Audio Ready" --text="$msg" --no-wrap --timeout=8
fi
}

sleep 10
cnt=0
while [ ! -f /etc/konahqss/soundready ]; do
  sleep 1
  cnt=$(($cnt+1))
  if [ $cnt -gt 20 ]; then
    exit
  fi
done
rm /etc/konahqss/soundready

if [ -z "$(grep ^normal /etc/konahqss/mode)" ] && [ -z "$(grep ^clear /etc/konahqss/mode)" ]; then
  soundreadymsg
  exit
fi
#if [ -z "$(which systemctl 2> /dev/null)" ]; then
#  soundreadymsg
#  exit
#fi

if [ -z "$(pgrep pulseaudio)" ] && [ -z "$(pgrep pipewire)" ]; then
  soundreadymsg
  exit
fi

if [ ! -z "$(pgrep pulseaudio)" ]; then
  if [ ! -z "$(which systemctl 2> /dev/null)" ]; then
    systemctl --user restart pulseaudio
    echo "Restart pulseaudio" >> /etc/konahqss/log
  else
    killall pulseaudio
    echo kill pulseaudio >> /etc/konahqss/log
  fi
elif [ ! -z "$(pgrep pipewire)" ]; then
  if [ ! -z "$(which systemctl 2> /dev/null)" ]; then
    systemctl --user restart pipewire
    echo "Restart pipewire" >> /etc/konahqss/log
  else
    killall pipewire
    echo kill pipewire >> /etc/konahqss/log
  fi
fi
soundreadymsg
if [ -z "$(pgrep pulseaudio)" ] && [ -z "$(pgrep pipewire)" ]; then
  if [ ! -z "$(locale|grep ja_JP)" ]; then
    zenity --warning --title="サーバー再起動" --text="再ログインしてください" --no-wrap
  else
    zenity --warning --title="Restart sound server" --text="Please login again" --no-wrap
  fi
fi
