#!/bin/bash
. /etc/konahqss/konahqss.inc

timeslices="10!20!25!50!100"
#mtulist="256!512!768!1024!1280!1500"
tones="medium!low!high!highlow" 
janrus="all!jazz!rock!classic!anison!edm!hard rock!heavy metal!live"
modes="normal!clear!soft!hifi!hifi(soft)"
#modes2="hifi!hifi(soft)!soft"

timeslice=$(cat /etc/konahqss/timeslice)
if [ ! -f /etc/konahqss/janru ]; then
  janru="all"
  tone="medium"
else
  janru=$(cat /etc/konahqss/janru)
  tone=$(cat /etc/konahqss/tone)
fi
if [ -f /etc/konahqss/ramplayer ]; then
  ramplayer="TRUE"
else
  ramplayer="FALSE"
fi
if [ -f /etc/konahqss/fastmemcpy ]; then
  hqsound="TRUE"
else
  hqsound="FALSE"
fi
if ([ ! -z "$(which systemctl 2> /dev/null)" ] || [ -f /etc/init.d/pulseaudio ] || [  -f /etc/init.d/pipewire ]) &&
   ([ ! -z "$(which pulseaudio 2> /dev/null)" ] || [ ! -z "$(which pipewire 2> /dev/null)" ]); then
  initmode="normal"
  modenable="1"
else
#  modes=$modes2
  if   [ ! -z "$(which pulseaudio 2> /dev/null)" ] || [ ! -z "$(which pipewire 2> /dev/null)" ]; then
    modenable="2"
    initmode="hifi"
  fi
  if [ ! -z "$(which systemctl 2> /dev/null)" ]; then
    modenable="3"
    initmode="soft"
  fi  
fi
if [ ! -f /etc/konahqss/mode ]; then
  mode="$initmode"
else
  mode=$(cat /etc/konahqss/mode)
fi
if [ -z "$modenable" ]; then
  mode="soft"
else
  if [  "$modenable" != "1" ]; then
    if [ "$mode" != "normal" ] && [ "$mode" != "clear" ] && [ "$mode" != "hifi" ] && [ "$mode" != "soft" ] && [ "$mode" != "hifi(soft)" ]; then
      if [ ! -z "$(locale|grep ja_JP)" ]; then
        zenity --warning --text="不正なモードです" --title="サウンドの設定" --no-wrap
      else
        zenity --warning --text="Invalid mode" --title="sound settings" --no-wrap
      fi
      exit
    fi
  fi 
fi      
if [ -d /etc/konahqss/soundrivers/$(uname -r) ]; then
  if [ -f /lib/modules/$(uname -r)/kernel/sound/core/snd-pcm.ko.org ]; then
    if [ ! -z "$(locale|grep ja_JP)" ]; then
      if [ -f /etc/konahqss/hqdriveready ]; then
        using="(動作中)"
      else
        using="(使用中)"
      fi
    else
      using="(used)"
    fi
  fi
  if [ ! -z "$modenable" ]; then
    if [ ! -z "$(locale|grep ja_JP)" ]; then
      ret=$(yad --form --center --title="サウンドの設定" --text="好みのサウンドに設定します\n" --image=/usr/share/pixmaps/sonata.png --field="ジャンル(all):CB" --field="プレイヤーをメモリーに置く:CHK" --field="高音質サウンドドライバーを使う$using:CHK" --field="モード:CB" "$janru!$janrus" "$ramplayer" "$hqsound" "$mode!$modes")
    else
      ret=$(yad --form --center --title="Sound Settings" --text="Set to your favorite sound\n" --image=/usr/share/pixmaps/sonata.png  --field="Janru(all):CB" --field="mode:CB" --field="Use High Quality Sound Driver:CHK" --field="Put the server in RAM" "$janru!$janrus" "$ramplayer" "$hqsound" "$mode!$modes")
    fi
  else
    if [ ! -z "$(locale|grep ja_JP)" ]; then
      ret=$(yad --form --center --title="サウンドの設定" --text="好みのサウンドに設定します\n" --image=/usr/share/pixmaps/sonata.png --field="ジャンル(all):CB" --field="プレイヤーをメモリーに置く:CHK" --field="高音質サウンドドライバーを使う$using:CHK" "$janru!$janrus" "$ramplayer" "$hqsound")
    else
      ret=$(yad --form --center --title="Sound Settings" --text="Set to your favorite sound\n" --image=/usr/share/pixmaps/sonata.png  --field="Janru(all):CB" --field="Put the player in RAM:CHK" --field="Use High Quality Sound Driver:CHK" "$janru!$janrus" "$ramplayer" "$hqsound")
    fi
  fi
else
  if [ ! -z "$modenable" ]; then
    if [ ! -z "$(locale|grep ja_JP)" ]; then
      ret=$(yad --form --center --title="サウンドの設定" --text="好みのサウンドに設定します\n" --image=/usr/share/pixmaps/sonata.png --field="ジャンル(all):CB" --field="プレイヤーをメモリーに置く:CHK" --field="モード:CB" "$janru!$janrus" "$ramplayer" "$mode!$modes")
    else
      ret=$(yad --form --center --title="Sound Settings" --text="Set to your favorite sound\n" --image=/usr/share/pixmaps/sonata.png  --field="Janru(all):CB" --field="Put the player in RAM:CHK" --field="mode:CB" "$janru!$janrus" "$ramplayer" "$mode!$modes")
    fi
  else
    if [ ! -z "$(locale|grep ja_JP)" ]; then
      ret=$(yad --form --center --title="サウンドの設定" --text="好みのサウンドに設定します\n" --image=/usr/share/pixmaps/sonata.png --field="ジャンル(all):CB" --field="プレイヤーをメモリーに置く:CHK" "$janru!$janrus" "$ramplayer")
    else
      ret=$(yad --form --center --title="Sound Settings" --text="Set to your favorite sound\n" --image=/usr/share/pixmaps/sonata.png  --field="Janru(all):CB" --field="Put the player in RAM:CHK" "$janru!$janrus" "$ramplayer")
    fi
  fi
fi
rcd="$?"
if [ "$rcd" = "0" ]; then
  janru=$(echo $ret|cut -d'|' -f1)
  case $janru in
    "all") tone="medium";;
    "jazz") tone="medium"
	    baseboost="true";;
    "classic") tone="low";;
    "live") tone="highlow";;
    "anison") tone="high";;
    "edm" | "rock") tone="high"
            baseboost="true";;
    "hard rock") tone="highlow"
            baseboost="true";;
    "heavy metal") tone="low"
            baseboost="true";;
  esac
  echo $tone > /etc/konahqss/tone
  if [ ! -z "$(echo tone|grep low)" ]; then
    echo 8192 > /etc/konahqss/rmem
  else
    rm -f /etc/konahqss/rmem
  fi
  echo $janru > /etc/konahqss/janru
  if [ "$baseboost" = "true" ]; then
    touch /etc/konahqss/baseboost
  else
    rm -f /etc/konahqss/baseboost
  fi
  if [ "$(echo $ret|cut -d'|' -f2)" = "TRUE" ]; then
    touch /etc/konahqss/ramplayer
  else
    rm -f /etc/konahqss/ramplayer
  fi
  if [ -d /etc/konahqss/soundrivers/$(uname -r) ]; then
    if [ "$(echo $ret|cut -d'|' -f3)" = "TRUE" ]; then
      touch /etc/konahqss/fastmemcpy
      if [ ! -z "$(locale|grep ja_JP)" ]; then
        zenity --warning --title="サウンドの設定" --text="高音質サウンドドライバーを使うときは\nセキュアブートをオフにしてください" --no-wrap
      else
        zenity --warning --title="Sound Settings" --text="Turn off secure boot when using high quality sound drivers" --no-wrap
      fi
    else
      rm -f /etc/konahqss/fastmemcpy
    fi
    mode=$(echo $ret|cut -d'|' -f4)
  else
    mode=$(echo $ret|cut -d'|' -f3)
  fi
  if [ "$modenable" != "1" ]; then
    if [ "$mode" = "normal" ] || [ "$mode" = "clear" ]; then
      if [ ! -z "$(locale|grep ja_JP)" ]; then
        zenity --warning --title="サウンドの設定" --text="Pulseaudioのautospawnが働くときは問題ありませんが\nそうでないときは音が出なくなります\nそのときは再ログインしてください" --no-wrap
      else
        zenity --warning --title="Sound settings" --text=" When Pulseaudio's autospawn works, there is no problem,\nbut when it doesn't, there is no sound.\nIn that case, please log in again" --no-wrap
      fi
    fi
  fi
  echo $mode > /etc/konahqss/mode
  if [ ! -z "$(locale|grep ja_JP)" ]; then
    zenity --info --title="サウンドの設定" --text="サウンドを設定しました\nシステムを再起動すると有効になります。" --no-wrap
  else
    zenity --info --title="Sound Settings" --text="Completed setting the sound\nIt will take effect when the system is restarted" --no-wrap
  fi
fi

